-- (c) 2006 Witold Bolt (ja@hope.art.pl)
CREATE OR REPLACE FUNCTION getUserGroups(integer) RETURNS SETOF integer AS
    'SELECT gid from uzytkownik_grupa where uid=$1' LANGUAGE 'SQL';

CREATE OR REPLACE FUNCTION getGroupUsers(integer) RETURNS SETOF integer AS
    'SELECT DISTINCT uid from uzytkownik_grupa WHERE gid=$1 ORDER BY uid' LANGUAGE 'SQL';

CREATE TYPE udd AS (uid integer, data_zwrotu date, data_wypozyczenia date);

CREATE OR REPLACE FUNCTION getEgzemplarzHistory(integer) RETURNS SETOF udd AS
    'SELECT uid,data_wypozyczenia,data_zwrotu FROM historia WHERE eid=$1' LANGUAGE 'SQL';

CREATE TYPE edd AS (eid integer, data_zwrotu date, data_wypozyczenia date);

CREATE OR REPLACE FUNCTION getUserHistory(integer) RETURNS SETOF edd AS
    'SELECT eid,data_wypozyczenia,data_zwrotu FROM historia WHERE uid=$1' LANGUAGE 'SQL';

CREATE TYPE ued AS (uid integer, eid integer, data_wypozyczenia timestamp);

CREATE OR REPLACE FUNCTION getProsbaForUser(integer) RETURNS SETOF ued AS
    'SELECT prosba_o_wypozyczenie.uid,prosba_o_wypozyczenie.eid,prosba_o_wypozyczenie.data
    FROM prosba_o_wypozyczenie INNER JOIN egzemplarz ON prosba_o_wypozyczenie.eid=egzemplarz.id WHERE egzemplarz.uid=$1' LANGUAGE 'SQL';

CREATE OR REPLACE FUNCTION getPozyczoneByUser(integer) RETURNS SETOF integer AS
    'SELECT eid FROM wypozyczenie WHERE uid=$1' LANGUAGE 'SQL';

CREATE OR REPLACE FUNCTION getPozyczoneByGroup(integer) RETURNS SETOF integer AS
    'SELECT eid FROM wypozyczenie INNER JOIN uzytkownik_grupa ON wypozyczenie.uid=uzytkownik_grupa.uid WHERE gid=$1' LANGUAGE 'SQL';

CREATE OR REPLACE FUNCTION getEgzemplarzAllowedGroups(integer) RETURNS SETOF integer AS
    'SELECT DISTINCT gid FROM uzytkownik_grupa WHERE uid IN (SELECT uid FROM egzemplarz WHERE id=$1) ORDER BY gid' LANGUAGE 'SQL';

CREATE OR REPLACE FUNCTION getEgzemplarzAllowedUsers(integer) RETURNS SETOF integer AS
    'SELECT DISTINCT uid FROM uzytkownik_grupa INNER JOIN (SELECT * FROM getEgzemplarzAllowedGroups($1) AS g) AS foo ON gid=foo.g ORDER BY uid' LANGUAGE 'SQL';

CREATE OR REPLACE FUNCTION mozna_wypozyczyc(integer) RETURNS BOOLEAN AS
    'SELECT moze_byc_wypozyczony FROM egzemplarz WHERE id = $1' LANGUAGE 'SQL';

CREATE OR REPLACE FUNCTION getEgzemplarzByBookUser(kid integer, uid integer) RETURNS SETOF integer AS
    'SELECT id FROM egzemplarz WHERE egzemplarz.kid = $1 AND $2 IN (SELECT * FROM getEgzemplarzAllowedUsers(id))' LANGUAGE 'SQL';

CREATE OR REPLACE FUNCTION getUserWypozyczenieCount(uid integer) RETURNS bigint AS
    'SELECT count(eid) FROM wypozyczenie WHERE uid = $1' LANGUAGE 'SQL';

CREATE OR REPLACE FUNCTION wypozyczenieLen(hid integer) RETURNS integer AS $$
    DECLARE
        hrow historia%ROWTYPE;
        teraz DATE := NOW();
    BEGIN
        SELECT INTO hrow * FROM historia WHERE id=hid;
        IF hrow.data_zwrotu IS NOT NULL THEN
            RETURN hrow.data_zwrotu - hrow.data_wypozyczenia;
        ELSE
            RETURN teraz - hrow.data_wypozyczenia;
        END IF;

    END;
$$ LANGUAGE plpgsql;
